/*
{some nifty licence stuff here}
copyright by Daniel T. Bender aka "HarvestMoon", 2002
mail to
	daniel@black-karma.de
	h4rv3st@web.de
	
Black Karma - http://www.black-karma.de
*/

#include <Application.h>
#include <Alert.h>
#include <Box.h>
#include <Button.h>
#include <CheckBox.h>
#include <ColorControl.h>
#include <ListView.h>
#include <ListItem.h>
#include <Message.h>
#include <Messenger.h>
#include <Point.h>
#include <RadioButton.h>
#include <Rect.h>
#include <Screen.h>
#include <ScrollView.h>
#include <Slider.h>
#include <String.h>
#include <TabView.h>
#include <TextControl.h>
#include <Window.h>

#include <iostream.h>
#include <stdio.h>
#include <ctype.h>

#include "PListItem.h"

const int DOCK_AUTO_HIDE			= 5001;
const int DOCK_DELAY_TIME			= 5002;
const int DOCK_POSITION_TOP			= 5003;
const int DOCK_POSITION_BOTTOM		= 5004;
const int DOCK_POSITION_LEFT		= 5005;
const int DOCK_POSITION_RIGHT		= 5006;
const int DOCK_COLOR				= 5007;
const int DOCK_TRANSPARENT_MENUS	= 5008;
const int DOCK_DRAW_OUTER_FRAME		= 5009;
const int DOCK_ALWAYS_ON_TOP		= 5010;
const int DOCK_HIDE_STD_DESKBAR		= 5011;
const int DOCK_USE_WINDOW_SHAPPING	= 5012;

const int TAB_COLOR				= 6001;
const int TAB_SAME_COLOR		= 6002;
const int TAB_AUTO_HIDE			= 6003;
const int TAB_NUMBER_OF_TABS	= 6004;
const int TAB_LISTITEM_INVOKED	= 6005;
const int TAB_LISTITEM_SELECTED = 6006;
const int TAB_NAME_CHANGED		= 6007;
const int TAB_CREATE_TAB		= 6008;
const int TAB_REMOVE_TAB		= 6009;
const int TAB_CPU_USAGE_BAR		= 6010;
const int TAB_ALPHA_HANDLES		= 6011;

class PWindow : public BWindow
{
	public:
						PWindow(BRect frame);
		virtual void	MessageReceived(BMessage *msg);
		virtual bool	QuitRequested();
		virtual bool	Put(BMessage *request);
		virtual bool	Fetch(char *target, char *what, int32 index = -1);
		virtual void	Apply(char *target, char *what, BMessage reply, int32 index = -1);
		virtual void	Request(char *target, char *what, int32 index = -1);
		virtual void	FillList(int32 count);
		virtual BString	TabFetchName(int32 index);
		virtual bool	TabFetchAutoHide(int32 index);
		virtual rgb_color	TabFetchColor(int32 index);
		virtual bool	TabFetchCpuBars(int32 index);
		virtual bool	TabFetchAlphaHandles(int32 index);
	
	protected:
		
		int32			tabcount;
		
		BTabView		*tabview;
		/**********/
		BTab			*tab_dock;
		BBox			*box_dock;
		
		BSlider			*dockdelaytime;
		BCheckBox		*dockautohide;
		BCheckBox		*docktransparentmenus;
		BCheckBox		*dockdrawouterframe;
		BCheckBox		*dockalwaysontop;
		BCheckBox		*dockhidestddeskbar;
		BCheckBox		*dockusewindowshapping;
		BColorControl	*dockcolorctrl;
		BRadioButton	*dockpostop, *dockposbottom, *dockposleft, *dockposright;
		/**********/
		BTab			*tab_tabs;
		BBox			*box_tabs;
		
		BButton			*new_tab;
		BButton			*remove_tab;
		BListView		*tablistview;
		BTextControl	*tabtextentry;
		BScrollView		*tablistscrollview;
		BColorControl	*tabcolorctrl;
		BCheckBox		*tabautohide;
		BCheckBox		*tabsamecolor;
		BCheckBox		*tabcpuusagebar;
		BCheckBox		*tabalphahandles;
};
