/*
{some nifty licence stuff here}
copyright by Daniel T. Bender aka "HarvestMoon", 2002
mail to
	daniel@black-karma.de
	h4rv3st@web.de
	
Black Karma - http://www.black-karma.de
*/

#include "PListItem.h"

PListItem::PListItem(BString name) : BListItem()
{
	itemName = name;
}

void PListItem::DrawItem(BView *parentView, BRect frame, bool complete = false)
{
	if (IsSelected()) parentView -> SetHighColor(SEL_COLOR);
	else parentView -> SetHighColor(BG_COLOR);
	parentView -> FillRect(frame);
	parentView -> SetHighColor(FG_COLOR);
	parentView -> MovePenTo(frame.left + 2, frame.bottom - 3);
	parentView -> DrawString(itemName.String());
}

void PListItem::SetName(const char *name)
{
	itemName = name;
}

BString PListItem::Name()
{
	return itemName;
}